﻿namespace FL
{
    public enum EventDefine : int
    {
        None = 0,

        #region GameMainMap 1000 - 1999
        /// <summary>
        /// 加载主角、随从、怪物等
        /// </summary>
        GameMainMapLoadEntities = 1000,
        /// <summary>
        /// 移除主角、随从、怪物
        /// </summary>
        GameMainMapRemoveEntity,
        /// <summary>
        /// 移除子弹、陷阱、召唤物等实例对象
        /// </summary>
        GameMainMapRemoveSimpleEntity,
        /// <summary>
        /// 血量变化
        /// </summary>
        GameMainMapHpAdd,
        /// <summary>
        /// 开启地图黑色遮罩
        /// </summary>
        GameMainMapStartMask,
        /// <summary>
        /// 地图黑色遮罩结束通知
        /// </summary>
        GameMainMapEndMask,
        /// <summary>
        /// 创建子弹实例
        /// </summary>
        GameMainMapGenBullet,
        /// <summary>
        /// 创建陷阱实例
        /// </summary>
        GameMainMapGenCommons,
        /// <summary>
        /// 更换随从
        /// </summary>
        GameMainMapExchangePartner,
        /// <summary>
        /// buff变化
        /// 只有元素buff变化会通知
        /// </summary>
        GameMainMapAddBuff,
        /// <summary>
        /// buff状态改变
        /// 只有元素buff变化会通知
        /// </summary>
        GameMainMapRemoveBuff,
        /// <summary>
        /// buff预览
        /// </summary>
        GameMainMapPreviewBuff,
        /// <summary>
        /// 请求预览Buff列表
        /// </summary>
        GameMainMapReqPreviewBuffs,
        /// <summary>
        /// 广播预览Buff列表
        /// </summary>
        GameMainMapPushPreviewBuffs,
        #endregion
        #region Battle.Component 2000 - 2999
        /// <summary>
        /// 播放世界特效
        /// </summary>
        VfxComponentWorldVfx = 2000,
        #endregion

        #region 装备相关 3000 - 3099
        /// <summary>
        /// 更换装备
        /// </summary>
        OnChangeEquip = 3000,
        #endregion

        #region DragonEgg.Component 3100 - 3199
        /// <summary>
        /// 龙蛋填充能量槽
        /// </summary>
        FillEnergy = 3101,
        /// <summary>
        /// 龙蛋升级中
        /// </summary>
        UpgradeDragonEgg,
        /// <summary>
        /// 减少龙蛋升级时间
        /// </summary>
        ReduceDragonEggTime,
        /// <summary>
        /// 龙蛋升级成功
        /// </summary>
        UpgradeDragonEggSucess,
        /// <summary>
        /// 掉落装备
        /// </summary>
        DropEquip,
        #endregion

        #region 道具变化相关 3200 - 3299
        /// <summary>
        /// 道具变化
        /// </summary>
        UpdataItemData = 3200,
        #endregion

        #region 随从 Partner 3300 - 3399
        /// <summary>
        /// 随从上阵
        /// </summary>
        PartnerUp = 3300,
        /// <summary>
        /// 随从下阵
        /// </summary>
        PartnerDown,
        #endregion
        #region Toasts Tips 3400 - 3499
        ShowTips = 3400,
        #endregion

        #region 角色属性变化3500-3599
        AttributeChange = 3500,
        PlayerExpAdd,
        #endregion
    }
}
