﻿namespace XGame.Editor.Build.AssetBundles
{
    /// <summary>
    /// 资源逻辑的扩展接口，允许项目组自定义一些逻辑
    /// </summary>
    public interface IAssetsCustomHandler
    {
        /// <summary>
        /// 是否只分离分包的AB<br/>
        /// 为true时，Addressable的bundle没在分包列表里的优先保存在包内
        /// </summary>
        bool IsOnlySplitCustomPackageBundles { get; }

        /// <summary>
        /// 是否包内资源<br/>
        /// 默认返回false
        /// </summary>
        bool IsInnerAsset(string assetPath);

        /// <summary>
        /// 是否使用 I18NKey转换成HashKey 的优化功能<br/>
        /// 默认返回true
        /// </summary>
        bool IsUseI18NHashKey();
    }
}