﻿namespace XGame.Editor.Build
{
    public partial class BuildConfig
    {
        public struct ProjectSettings
        {
            public string projectId;
            public string productName;
            public string applicationIdentifier;
            public string bundleVersion;
            public string versionCode;
            public string assetVersionName;
            public int assetVersionCode;
            /// <summary>
            /// 忽略生成ilrt代码
            /// </summary>
            public bool isIgnoreGenIlrt;
            /// <summary>
            /// 输出目录
            /// </summary>
            public string outputPath;
            [System.Obsolete]
            /// <summary>
            /// 是否强制重构Assetbundle
            /// sbp推荐每次打包都是全量打包
            /// </summary>
            public bool isForceRebuildAB;
            /// <summary>
            /// 打包完是否保存 *.SpriteAtlas
            /// 打包默认删除
            /// 避免因为*.SpriteAtlas残留导致文件夹guid变化
            /// </summary>
            public bool isSaveSpriteAtlas;
        }
        public struct GitSettings
        {
            /// <summary>
            /// git操作使用的token
            /// </summary>
            [System.Obsolete]
            public string gitToken;
            /// <summary>
            /// 仓库地址(/分割后拿最后一个作为项目名)
            /// </summary>
            public string gitAddress;
            /// <summary>
            /// 分支
            /// </summary>
            public string branch;
            /// <summary>
            /// git的commitHash值
            /// </summary>
            public string commitHash;
        }
        public struct EditorSettings
        {
            /// <summary>
            /// 打完包自动打开文件夹
            /// </summary>
            public bool autoExplorer;
            /// <summary>
            /// 打包结束后自动退出Unity
            /// </summary>
            public bool autoExit;
            /// <summary>
            /// 是否是本地打包
            /// </summary>
            public bool isNative;
        }
        public struct AndroidSettings
        {
            /// <summary>
            /// Android有效
            /// </summary>
            public AndroidArchitecture architecture;
            /// <summary>
            /// 是否导出Android工程
            /// </summary>
            public bool exportAsGoogleAndroidProject;
            /// <summary>
            /// 是否分离二进制资源
            /// 分离obb资源包,Unity国际版才能使用
            /// </summary>
            [System.Obsolete("已废弃")]
            public bool splitApplicationBinary;
        }
        /// <summary>
        /// 预留
        /// </summary>
        public struct IOSSettings
        {
        }
    }
}
