﻿namespace XGame.Framework
{
    /// <summary>
    /// 事件派发器
    /// </summary>
    public interface IEventDispatcher
    {
        /// <summary>
        /// 派发事件（无上下文）
        /// </summary>
        /// <param name="eventId">事件ID</param>
        void Notify(int eventId);

        /// <summary>
        /// 派发事件
        /// </summary>
        /// <param name="eventId">事件ID</param>
        /// <param name="args">上下文</param>
        void Notify(int eventId, object args);
    }
}
