﻿using XGame.Framework.Define;

namespace XGame.Framework.Logger
{
    internal static class LogDefine
    {
        /// <summary>
        /// log的缓存上限
        /// </summary>
        public const uint CacheCapacityLimit = 64 * 1024;
        /// <summary>
        /// log文件的后缀
        /// </summary>
        public const string FileExtension = ".log";
        /// <summary>
        /// 日志的根目录
        /// </summary>
        public static string LogRootPath = $"{PathDefine.PersistentDataPath}/Logs";
        /// <summary>
        /// 代码日志路径
        /// </summary>
        public static string CodeLogPath = $"{LogRootPath}/Code";
        /// <summary>
        /// 事件日志路径
        /// </summary>
        public static string EventLogPath = $"{LogRootPath}/Event";
        /// <summary>
        /// 代码日志MemoryFile文件路径
        /// </summary>
        public static string CodeMMFPath = $"{LogRootPath}/codelogmemory.bytes";
        /// <summary>
        /// 事件日志MemoryFile文件路径
        /// </summary>
        public static string EventMMFPath = $"{LogRootPath}/eventlogmemory.bytes";

    }
}
