# FGUI注意事项



参考文档：

[FGUI编辑器教程](https://fairygui.com/docs/editor)

[装载器加载外部图集的合批问题](https://zhuanlan.zhihu.com/p/689636245)

#### 项目规范

1. 项目名字、路径、资源名字**不允许中文字符、空格**等符号，只能使用英文字母、数字、下划线的组合。

2. Package包名、窗口名字、组件名字等以驼峰方式命名，首字母大写

3. 窗口、组件的名字要能简单看出组件功能、类型，不要用无意义的字母或数字命名~~(如：Button1、Button2)~~

4. 需要导出的资源可以放在Package的根目录下，其他的推荐归类保存在各子文件夹内

5. UI窗口需要勾选：检查器->生成代码 ，导出资源时才会生成代码

   ![image-20240510181120823](ReadmeImg\image-20240510181120823.png)

   ![image-20240510181009337](ReadmeImg\image-20240510181009337.png)

6. 代码生成时会忽略使用默认名称(n+数字)的成员。参与生成代码的组件必须手动命名(驼峰方式命名，首字母大写)，并保持同一个窗口内名字唯一。

   <img src="ReadmeImg\image-20240510181235196.png" alt="image-20240510181235196" style="zoom:80%;" />

7. 窗口成员命名以组件类型做结尾，比如商店按钮命名为:ShopBtn，组件类型缩写如下：

   - 按钮: Btn
   - 文本:Label
   - 列表：List
   - 下拉框：Box
   - 滚动条：Scroll
   - 进度条：Pbar
   - 滑动条：Slider
   - 菜单: Menu
   - 动画：Movie
   - 字体：Font

8. Package的测试资源不能设置导出，统一放置在"noExport"文件夹内，同时必须手动设置资源排除，菜单：发布设置->包设置->排除资源

   <img src="ReadmeImg\image-20240510181905660.png" alt="image-20240510181905660" style="zoom:67%;" />

9. 公共资源使用“Common”为前缀命名包名，比如: CommonPkg1、CommonPkg2等。非公共资源包只允许使用包内资源和公共资源包，否则会出现资源引用丢失。

   ![image-20240510183337913](ReadmeImg\image-20240510183337913.png)

10. 未完待续

